Index: branches/HTM-14.0-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1187)
@@ -2721,4 +2721,65 @@
 }
 
+#if H_3D
+Void TComVPS::initViewCompLayer()
+{
+  assert( m_viewCompLayerId.size() == 0 && m_viewCompLayerPresentFlag.size() == 0  );
+  for( Int i = 0; i < getNumViews(); i++ )
+  {
+    m_viewCompLayerId         .push_back( std::vector<Int>(0)  );
+    m_viewCompLayerPresentFlag.push_back( std::vector<Bool>(0) );      
+
+    for( Int depFlag = 0; depFlag  <=  1; depFlag++ )
+    {
+      Int iViewOIdx = getViewOIdxList( i );
+      Int layerId = -1;
+      for( Int j = 0; j  <=  getMaxLayersMinus1(); j++ ) 
+      {
+        Int jNuhLId = getLayerIdInNuh( j );
+        if( getVpsDepthFlag( jNuhLId ) == ( (Bool) depFlag )  &&  getViewOrderIdx( jNuhLId )  ==  iViewOIdx  
+          &&  getDependencyId( jNuhLId )  ==  0  &&  getAuxId( jNuhLId )  ==  0 )
+        {
+          layerId = jNuhLId;
+        }
+      }
+      m_viewCompLayerPresentFlag[ i ].push_back( layerId  !=  -1 );
+      m_viewCompLayerId         [ i ].push_back( layerId );        
+    }
+  }
+}
+
+Int TComVPS::getVoiInVps(Int viewOIdx)
+{
+  for ( Int i = 0; i < m_viewOIdxList.size(); i++ )
+  {
+    if  ( m_viewOIdxList[ i ] == viewOIdx )
+    {
+      return i; 
+    }
+  }
+  assert( 0 );   
+  return -1;
+}
+
+Void TComVPS::deriveCpPresentFlag()
+{
+  for( Int nInVps = 0; nInVps < getNumViews(); nInVps++  )
+  {
+    for( Int mInVps = 0; mInVps < getNumViews(); mInVps++ )
+    {
+      m_cpPresentFlag[nInVps][mInVps] = 0; 
+    }
+  }
+
+  for( Int n = 1; n < getNumViews(); n++ )
+  {
+    Int iInVps = getVoiInVps(  getViewOIdxList( n ) );      
+    for( Int m = 0; m < getNumCp( iInVps ); m++ )
+    {
+      m_cpPresentFlag[ iInVps ][ getVoiInVps( getCpRefVoi( iInVps, m ) ) ] = 1;
+    }
+  }
+}
+#endif
 
 #endif // H_MV
@@ -3824,5 +3885,7 @@
 }
 #endif
+
 #if H_3D_IC
+// This is an encoder only function and should be moved to TEncSlice or TEncSearch!!
 Void TComSlice::xSetApplyIC(Bool bUseLowLatencyICEnc)
 {
@@ -3888,78 +3951,75 @@
   }
   else
-  {
-  Int iMaxPelValue = ( 1 << g_bitDepthY ); 
-  Int *aiRefOrgHist;
-  Int *aiCurrHist;
-  aiRefOrgHist = (Int *) xMalloc( Int,iMaxPelValue );
-  aiCurrHist   = (Int *) xMalloc( Int,iMaxPelValue );
-  memset( aiRefOrgHist, 0, iMaxPelValue*sizeof(Int) );
-  memset( aiCurrHist, 0, iMaxPelValue*sizeof(Int) );
-  // Reference Idx Number
-  Int iNumRefIdx = getNumRefIdx( REF_PIC_LIST_0 );
-  TComPic* pcCurrPic = NULL;
-  TComPic* pcRefPic = NULL;
-  TComPicYuv* pcCurrPicYuv = NULL;
-  TComPicYuv* pcRefPicYuvOrg = NULL;
-  pcCurrPic = getPic();
-  pcCurrPicYuv = pcCurrPic->getPicYuvOrg();
-  Int iWidth = pcCurrPicYuv->getWidth();
-  Int iHeight = pcCurrPicYuv->getHeight();
-
-
-  // Get InterView Reference picture
-  // !!!!! Assume only one Interview Reference Picture in L0
-  for ( Int i = 0; i < iNumRefIdx; i++ )
-  {
-    pcRefPic = getRefPic( REF_PIC_LIST_0, i );
-    if ( pcRefPic != NULL )
-    {
-      if ( pcCurrPic->getViewIndex() != pcRefPic->getViewIndex() )
-      {
-        pcRefPicYuvOrg = pcRefPic->getPicYuvOrg();
-      }
-    }
-  }
-
-  if ( pcRefPicYuvOrg != NULL )
-  {
-    Pel* pCurrY = pcCurrPicYuv ->getLumaAddr();
-    Pel* pRefOrgY = pcRefPicYuvOrg  ->getLumaAddr();
-    Int iCurrStride = pcCurrPicYuv->getStride();
-    Int iRefStride = pcRefPicYuvOrg->getStride();
-    Int iSumOrgSAD = 0;
-    Double dThresholdOrgSAD = getIsDepth() ? 0.1 : 0.05;
-
-    // Histogram building - luminance
-    for ( Int y = 0; y < iHeight; y++ )
-    {
-      for ( Int x = 0; x < iWidth; x++ )
-      {
-        aiCurrHist[pCurrY[x]]++;
-        aiRefOrgHist[pRefOrgY[x]]++;
-      }
-      pCurrY += iCurrStride;
-      pRefOrgY += iRefStride;
-    }
-    // Histogram SAD
-    for ( Int i = 0; i < iMaxPelValue; i++ )
-    {
-      iSumOrgSAD += abs( aiCurrHist[i] - aiRefOrgHist[i] );
-    }
-    // Setting
-    if ( iSumOrgSAD > Int( dThresholdOrgSAD * iWidth * iHeight ) )
-    {
-      m_bApplyIC = true;
-    }
-    else
-    {
-      m_bApplyIC = false;
-    }
-  }
-
-  xFree( aiCurrHist   );
-  xFree( aiRefOrgHist );
-  aiCurrHist = NULL;
-  aiRefOrgHist = NULL;
+  {        
+    TComPic*    pcCurrPic = getPic();
+    TComPicYuv* pcCurrPicYuv = pcCurrPic->getPicYuvOrg();
+    
+    // Get InterView Reference picture
+    // !!!!! Assume only one Interview Reference Picture in L0
+    // GT: Is this assumption correct?
+
+    TComPicYuv* pcRefPicYuvOrg = NULL;
+    for ( Int i = 0; i < getNumRefIdx( REF_PIC_LIST_0 ); i++ )
+    {
+      TComPic* pcRefPic = getRefPic( REF_PIC_LIST_0, i );
+      if ( pcRefPic != NULL )
+      {
+        if ( pcCurrPic->getViewIndex() != pcRefPic->getViewIndex() )
+        {
+          pcRefPicYuvOrg = pcRefPic->getPicYuvOrg();
+        }
+      }
+    }
+
+    if ( pcRefPicYuvOrg != NULL )
+    {
+      // Histogram building - luminance
+      Int iMaxPelValue = ( 1 << g_bitDepthY ); 
+      Int *aiRefOrgHist = (Int *) xMalloc( Int,iMaxPelValue );
+      Int *aiCurrHist   = (Int *) xMalloc( Int,iMaxPelValue );
+      memset( aiRefOrgHist, 0, iMaxPelValue*sizeof(Int) );
+      memset( aiCurrHist, 0, iMaxPelValue*sizeof(Int) );
+
+      Int iWidth   = pcCurrPicYuv->getWidth();
+      Int iHeight  = pcCurrPicYuv->getHeight();
+
+      Pel* pCurrY   = pcCurrPicYuv ->getLumaAddr();
+      Pel* pRefOrgY = pcRefPicYuvOrg  ->getLumaAddr();
+      Int iCurrStride = pcCurrPicYuv->getStride();
+      Int iRefStride = pcRefPicYuvOrg->getStride();
+
+      for ( Int y = 0; y < iHeight; y++ )
+      {
+        for ( Int x = 0; x < iWidth; x++ )
+        {
+          aiCurrHist[pCurrY[x]]++;
+          aiRefOrgHist[pRefOrgY[x]]++;
+        }
+        pCurrY += iCurrStride;
+        pRefOrgY += iRefStride;
+      }
+
+      // Histogram SAD
+      Int iSumOrgSAD = 0;
+      for ( Int i = 0; i < iMaxPelValue; i++ )
+      {
+        iSumOrgSAD += abs( aiCurrHist[i] - aiRefOrgHist[i] );
+      }
+
+      // Setting
+      Double dThresholdOrgSAD = getIsDepth() ? 0.1 : 0.05;
+
+      if ( iSumOrgSAD > Int( dThresholdOrgSAD * iWidth * iHeight ) )
+      {
+        m_bApplyIC = true;
+      }
+      else
+      {
+        m_bApplyIC = false;
+      }
+
+      xFree( aiCurrHist   );
+      xFree( aiRefOrgHist );
+    }
   }//if(bUseLowLatencyICEnc)
 }
@@ -4136,4 +4196,86 @@
 #endif
 }
+
+Void TComSlice::deriveInCmpPredAndCpAvailFlag()
+{
+  Int numCurCmpLIds = getIsDepth() ? 1 : getNumActiveRefLayerPics(); 
+  std::vector<Int> curCmpLIds;
+  if ( getIsDepth() )
+  {
+    curCmpLIds.push_back( getLayerId() );
+  }
+  else
+  {
+    for (Int i = 0; i < numCurCmpLIds; i++)
+    {
+      curCmpLIds.push_back( getRefPicLayerId( i ) );
+    }
+  }
+
+  m_cpAvailableFlag = true;
+  m_inCmpRefViewIdcs.clear();
+  Bool allRefCmpLayersAvailFlag = true;
+
+  for( Int i = 0; i <= numCurCmpLIds - 1; i++ )
+  {      
+    m_inCmpRefViewIdcs.push_back( getVPS()->getViewOrderIdx( curCmpLIds[ i ] ));
+    if( !getVPS()->getCpPresentFlag( getVPS()->getVoiInVps( getViewIndex() ),  getVPS()->getVoiInVps( m_inCmpRefViewIdcs[ i ] ) ) )
+    {
+      m_cpAvailableFlag = false;
+    }
+    Bool refCmpCurLIdAvailFlag = false;
+    if( getVPS()->getViewCompLayerPresentFlag( m_inCmpRefViewIdcs[ i ], !getIsDepth() ) )
+    {
+      Int j = getVPS()->getLayerIdInVps( getVPS()->getViewCompLayerId( m_inCmpRefViewIdcs[ i ],  !getIsDepth() ) );
+      if  ( getVPS()->getDirectDependencyFlag( getVPS()->getLayerIdInVps( getLayerId() ) ,  j ) &&
+        getVPS()->getSubLayersVpsMaxMinus1( j ) >= getTemporalId()   &&
+        ( getTemporalId() == 0 || getVPS()->getMaxTidIlRefPicsPlus1( j , getVPS()->getLayerIdInVps( getLayerId() ) ) > getTemporalId() )        
+        )
+      {
+        refCmpCurLIdAvailFlag = true;
+      }
+    }
+    if( !refCmpCurLIdAvailFlag )
+    {
+      allRefCmpLayersAvailFlag = false;
+    }
+  }
+
+  if( !allRefCmpLayersAvailFlag )
+  {
+    m_inCmpPredAvailFlag = false;
+  }  
+  else 
+  {
+    TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
+    if( !getIsDepth() )
+    {
+      m_inCmpPredAvailFlag = sps3dExt->getViewSynthesisPredFlag( getIsDepth() ) || 
+        sps3dExt->getDepthBasedBlkPartFlag( getIsDepth() ) || 
+        sps3dExt->getDepthRefinementFlag  ( getIsDepth() );                            
+    }
+    else
+    {
+      m_inCmpPredAvailFlag = sps3dExt->getIntraContourFlag( getIsDepth() ) || 
+        sps3dExt->getQtPredFlag( getIsDepth() ) || 
+        sps3dExt->getMpiFlag( getIsDepth() );                                  
+    }
+  }
+}
+
+Void TComSlice::checkInCompPredRefLayers()
+{
+  if ( getInCompPredFlag() )
+  {
+    for (Int i = 0; i < getNumCurCmpLIds(); i++ )
+    {
+      assert( getIvPic(!getIsDepth(), getInCmpRefViewIdcs( i ) ) != NULL );       
+      //  It is a requirement of bitstream conformance that there 
+      //  is a picture in the DPB with PicOrderCntVal equal to the PicOrderCntVal of the current picture, 
+      //  and a nuh_layer_id value equal to ViewCompLayerId[ inCmpRefViewIdcs[ i ] ][ !DepthFlag ].
+    }
+  }
+}
+
 #endif
 
Index: branches/HTM-14.0-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1187)
@@ -912,4 +912,5 @@
   Int         xGetDimBitOffset( Int j );
   Void        xSetRefLayerFlags( Int currLayerId );
+
   // VPS EXTENSION 2 SYNTAX ELEMENTS
 #if H_3D
@@ -1011,5 +1012,6 @@
   Void    setVpsNonVuiExtensionLength( Int  val )                          { m_vpsNonVuiExtensionLength = val; } 
   Int     getVpsNonVuiExtensionLength(  )                                  { return m_vpsNonVuiExtensionLength; } 
-
+  
+  // VPS Extension
   Void    setSplittingFlag( Bool val )                                     { m_splittingFlag = val;  }
   Bool    getSplittingFlag()                                               { return m_splittingFlag; }
@@ -1154,47 +1156,9 @@
   Void    initNumViews();
 #if H_3D
-  Void   initViewCompLayer( )
-  { 
-    assert( m_viewCompLayerId.size() == 0 && m_viewCompLayerPresentFlag.size() == 0  );
-    for( Int i = 0; i < getNumViews(); i++ )
-    {
-      m_viewCompLayerId         .push_back( std::vector<Int>(0)  );
-      m_viewCompLayerPresentFlag.push_back( std::vector<Bool>(0) );      
-
-      for( Int depFlag = 0; depFlag  <=  1; depFlag++ )
-      {
-        Int iViewOIdx = getViewOIdxList( i );
-        Int layerId = -1;
-        for( Int j = 0; j  <=  getMaxLayersMinus1(); j++ ) 
-        {
-          Int jNuhLId = getLayerIdInNuh( j );
-          if( getVpsDepthFlag( jNuhLId ) == ( (Bool) depFlag )  &&  getViewOrderIdx( jNuhLId )  ==  iViewOIdx  
-            &&  getDependencyId( jNuhLId )  ==  0  &&  getAuxId( jNuhLId )  ==  0 )
-          {
-            layerId = jNuhLId;
-          }
-        }
-        m_viewCompLayerPresentFlag[ i ].push_back( layerId  !=  -1 );
-        m_viewCompLayerId         [ i ].push_back( layerId );        
-      }
-    }
-  };
-
-
+  Void   initViewCompLayer( );
   Int     getViewOIdxList( Int i )                                         { return m_viewOIdxList[i]; }
   std::vector<Int> getViewOIdxList( )                                               { return m_viewOIdxList; }
 
-  Int     getVoiInVps( Int viewOIdx )                                      
-  {    
-    for ( Int i = 0; i < m_viewOIdxList.size(); i++ )
-    {
-      if  ( m_viewOIdxList[ i ] == viewOIdx )
-      {
-        return i; 
-      }
-    }
-    assert( 0 );   
-    return -1; 
-  };
+  Int     getVoiInVps( Int viewOIdx );;
 
   Bool    getViewCompLayerPresentFlag (Int i, Bool d ) { return  m_viewCompLayerPresentFlag[ getVoiInVps(i) ][d]; }
@@ -1349,23 +1313,5 @@
 
 // Derived
-  Void deriveCpPresentFlag( )
-  {
-    for( Int nInVps = 0; nInVps < getNumViews(); nInVps++  )
-    {
-      for( Int mInVps = 0; mInVps < getNumViews(); mInVps++ )
-      {
-        m_cpPresentFlag[nInVps][mInVps] = 0; 
-      }
-    }
-
-   for( Int n = 1; n < getNumViews(); n++ )
-   {
-      Int iInVps = getVoiInVps(  getViewOIdxList( n ) );      
-      for( Int m = 0; m < getNumCp( iInVps ); m++ )
-      {
-         m_cpPresentFlag[ iInVps ][ getVoiInVps( getCpRefVoi( iInVps, m ) ) ] = 1;
-      }
-    }
-  }
+  Void deriveCpPresentFlag( );
 
   Void setCpPresentFlag( Int i, Int m, Bool flag ) { m_cpPresentFlag[i][m] = flag; } 
@@ -2480,6 +2426,6 @@
   Bool      m_bApplyDIS;
 #if H_3D_IC
-  Int *m_aICEnableCandidate;
-  Int *m_aICEnableNum;
+  Int*      m_aICEnableCandidate;
+  Int*      m_aICEnableNum;
 #endif
   Int       m_iDefaultRefViewIdx;
@@ -2930,86 +2876,7 @@
 #if H_3D
   // 3D-HEVC tool parameters
-  Void deriveInCmpPredAndCpAvailFlag()
-  { 
-    Int numCurCmpLIds = getIsDepth() ? 1 : getNumActiveRefLayerPics(); 
-    std::vector<Int> curCmpLIds;
-    if ( getIsDepth() )
-    {
-      curCmpLIds.push_back( getLayerId() );
-    }
-    else
-    {
-      for (Int i = 0; i < numCurCmpLIds; i++)
-      {
-        curCmpLIds.push_back( getRefPicLayerId( i ) );
-      }
-    }
-
-    m_cpAvailableFlag = true;
-    m_inCmpRefViewIdcs.clear();
-    Bool allRefCmpLayersAvailFlag = true;
-
-    for( Int i = 0; i <= numCurCmpLIds - 1; i++ )
-    {      
-      m_inCmpRefViewIdcs.push_back( getVPS()->getViewOrderIdx( curCmpLIds[ i ] ));
-      if( !getVPS()->getCpPresentFlag( getVPS()->getVoiInVps( getViewIndex() ),  getVPS()->getVoiInVps( m_inCmpRefViewIdcs[ i ] ) ) )
-      {
-        m_cpAvailableFlag = false;
-      }
-      Bool refCmpCurLIdAvailFlag = false;
-      if( getVPS()->getViewCompLayerPresentFlag( m_inCmpRefViewIdcs[ i ], !getIsDepth() ) )
-      {
-        Int j = getVPS()->getLayerIdInVps( getVPS()->getViewCompLayerId( m_inCmpRefViewIdcs[ i ],  !getIsDepth() ) );
-        if  ( getVPS()->getDirectDependencyFlag( getVPS()->getLayerIdInVps( getLayerId() ) ,  j ) &&
-          getVPS()->getSubLayersVpsMaxMinus1( j ) >= getTemporalId()   &&
-          ( getTemporalId() == 0 || getVPS()->getMaxTidIlRefPicsPlus1( j , getVPS()->getLayerIdInVps( getLayerId() ) ) > getTemporalId() )        
-          )
-        {
-          refCmpCurLIdAvailFlag = true;
-        }
-      }
-      if( !refCmpCurLIdAvailFlag )
-      {
-        allRefCmpLayersAvailFlag = false;
-      }
-    }
-
-    if( !allRefCmpLayersAvailFlag )
-    {
-      m_inCmpPredAvailFlag = false;
-    }  
-    else 
-    {
-      TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
-      if( !getIsDepth() )
-      {
-        m_inCmpPredAvailFlag = sps3dExt->getViewSynthesisPredFlag( getIsDepth() ) || 
-          sps3dExt->getDepthBasedBlkPartFlag( getIsDepth() ) || 
-          sps3dExt->getDepthRefinementFlag  ( getIsDepth() );                            
-      }
-      else
-      {
-        m_inCmpPredAvailFlag = sps3dExt->getIntraContourFlag( getIsDepth() ) || 
-          sps3dExt->getQtPredFlag( getIsDepth() ) || 
-          sps3dExt->getMpiFlag( getIsDepth() );                                  
-      }
-    }  
-  };
-
-
+  Void deriveInCmpPredAndCpAvailFlag();
   Void init3dToolParameters();   
-  Void checkInCompPredRefLayers()
-  {
-    if ( getInCompPredFlag() )
-    {
-      for (Int i = 0; i < getNumCurCmpLIds(); i++ )
-      {
-        assert( getIvPic(!getIsDepth(), getInCmpRefViewIdcs( i ) ) != NULL );       
-        //  It is a requirement of bitstream conformance that there 
-        //  is a picture in the DPB with PicOrderCntVal equal to the PicOrderCntVal of the current picture, 
-        //  and a nuh_layer_id value equal to ViewCompLayerId[ inCmpRefViewIdcs[ i ] ][ !DepthFlag ].
-      }
-    }
-  };
+  Void checkInCompPredRefLayers();;
 
   Bool getIvMvPredFlag           ( ) { return m_ivMvPredFlag           ; };
Index: branches/HTM-14.0-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 1187)
@@ -306,4 +306,5 @@
 #define H_3D_DISABLE_CHROMA                    1 
 #define H_3D_OUTPUT_ACTIVE_TOOLS               0
+#define H_3D_REN_MAX_DEV_OUT                   0
 #endif
 
Index: branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1187)
@@ -593,5 +593,5 @@
   UInt uiTPelY   = pcCU->getCUPelY() + g_auiRasterToPelY[ g_auiZscanToRaster[uiAbsPartIdx] ];
   UInt uiBPelY   = uiTPelY + (g_uiMaxCUHeight>>uiDepth) - 1;
-  
+
   UInt uiCurNumParts    = pcPic->getNumPartInCU() >> (uiDepth<<1);
   TComSlice * pcSlice = pcCU->getPic()->getSlice(pcCU->getPic()->getCurrSliceIdx());
@@ -601,5 +601,5 @@
     bBoundary = true;
   }
-  
+
   if( ( ( uiDepth < pcCU->getDepth( uiAbsPartIdx ) ) && ( uiDepth < g_uiMaxCUDepth - g_uiAddCUDepth ) ) || bBoundary )
   {
@@ -611,5 +611,5 @@
       uiLPelX = pcCU->getCUPelX() + g_auiRasterToPelX[ g_auiZscanToRaster[uiIdx] ];
       uiTPelY = pcCU->getCUPelY() + g_auiRasterToPelY[ g_auiZscanToRaster[uiIdx] ];
-      
+
       Bool binSlice = (pcCU->getSCUAddr()+uiIdx+uiQNumParts>pcSlice->getSliceSegmentCurStartCUAddr())&&(pcCU->getSCUAddr()+uiIdx<pcSlice->getSliceSegmentCurEndCUAddr());
       if(binSlice&&( uiLPelX < pcSlice->getSPS()->getPicWidthInLumaSamples() ) && ( uiTPelY < pcSlice->getSPS()->getPicHeightInLumaSamples() ) )
@@ -617,5 +617,5 @@
         xDecompressCU(pcCU, uiIdx, uiNextDepth );
       }
-      
+
       uiIdx += uiQNumParts;
     }
@@ -625,17 +625,17 @@
   // Residual reconstruction
   m_ppcYuvResi[uiDepth]->clear();
-  
+
   m_ppcCU[uiDepth]->copySubCU( pcCU, uiAbsPartIdx, uiDepth );
 
   switch( m_ppcCU[uiDepth]->getPredictionMode(0) )
   {
-    case MODE_INTER:
+  case MODE_INTER:
 #if H_3D_DBBP
-      if( m_ppcCU[uiDepth]->getDBBPFlag(0) )
-      {
-        xReconInterDBBP( m_ppcCU[uiDepth], uiAbsPartIdx, uiDepth );
-      }
-      else
-      {
+    if( m_ppcCU[uiDepth]->getDBBPFlag(0) )
+    {
+      xReconInterDBBP( m_ppcCU[uiDepth], uiAbsPartIdx, uiDepth );
+    }
+    else
+    {
 #endif
 #if H_3D_INTER_SDC
@@ -647,31 +647,31 @@
       {
 #endif
-      xReconInter( m_ppcCU[uiDepth], uiDepth );
+        xReconInter( m_ppcCU[uiDepth], uiDepth );
 #if H_3D_INTER_SDC
       }
 #endif
 #if H_3D_DBBP
-      }
-#endif
-      break;
-    case MODE_INTRA:
+    }
+#endif
+    break;
+  case MODE_INTRA:
 #if H_3D
-      if( m_ppcCU[uiDepth]->getDISFlag(0) )
-      {
-        xReconDIS( m_ppcCU[uiDepth], 0, uiDepth );
-      }
+    if( m_ppcCU[uiDepth]->getDISFlag(0) )
+    {
+      xReconDIS( m_ppcCU[uiDepth], 0, uiDepth );
+    }
 #if H_3D_DIM_SDC
-      else if( m_ppcCU[uiDepth]->getSDCFlag(0) )
-      {
-        xReconIntraSDC( m_ppcCU[uiDepth], 0, uiDepth );
-      }
-#endif
-      else
+    else if( m_ppcCU[uiDepth]->getSDCFlag(0) )
+    {
+      xReconIntraSDC( m_ppcCU[uiDepth], 0, uiDepth );
+    }
+#endif
+    else
 #endif
       xReconIntraQT( m_ppcCU[uiDepth], uiDepth );
-      break;
-    default:
-      assert(0);
-      break;
+    break;
+  default:
+    assert(0);
+    break;
   }
   if ( m_ppcCU[uiDepth]->isLosslessCoded(0) && (m_ppcCU[uiDepth]->getIPCMFlag(0) == false))
@@ -679,5 +679,5 @@
     xFillPCMBuffer(m_ppcCU[uiDepth], uiDepth);
   }
-  
+
   xCopyToPic( m_ppcCU[uiDepth], pcPic, uiAbsPartIdx, uiDepth );
 }
@@ -847,5 +847,5 @@
   AOF(bValidMask);
   
-  DBBPTmpData* pDBBPTmpData = pcCU->getDBBPTmpData();
+  DbbpTmpData* pDBBPTmpData = pcCU->getDBBPTmpData();
   TComYuv* apSegPredYuv[2] = { m_ppcYuvReco[uiDepth], m_ppcYuvRecoDBBP[uiDepth] };
   
Index: branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 1187)
@@ -220,9 +220,7 @@
 #endif
 #if H_3D_SPIVMP
-  Bool bSPIVMPFlag[MRG_MAX_NUM_CANDS_MEM];
-  TComMvField*  pcMvFieldSP;
-  UChar* puhInterDirSP;
-  pcMvFieldSP = new TComMvField[pcCU->getPic()->getPicSym()->getNumPartition()*2]; 
-  puhInterDirSP = new UChar[pcCU->getPic()->getPicSym()->getNumPartition()]; 
+  Bool bSPIVMPFlag[MRG_MAX_NUM_CANDS_MEM];     
+  TComMvField*  pcMvFieldSP = new TComMvField[pcCU->getPic()->getPicSym()->getNumPartition()*2]; 
+  UChar* puhInterDirSP = new UChar[pcCU->getPic()->getPicSym()->getNumPartition()]; 
 #endif
   for ( UInt ui = 0; ui < pcCU->getSlice()->getMaxNumMergeCand(); ui++ )
@@ -489,10 +487,4 @@
         }
       }
-#if H_3D_ARP
-      decodeARPW  ( pcCU, uiAbsPartIdx, uiDepth );
-#endif
-#if H_3D_IC
-      decodeICFlag( pcCU, uiAbsPartIdx, uiDepth );
-#endif
     }
     if ( (pcCU->getInterDir(uiSubPartIdx) == 3) && pcSubCU->isBipredRestriction(uiPartIdx) )
@@ -735,15 +727,15 @@
       if (pcCU->getSlice()->getSPS()->getChromaFormatIdc() != 0 )      
       {
-      if( bFirstCbfOfCU || pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, uiTrDepth - 1 ) )
-      {
-        m_pcEntropyDecoderIf->parseQtCbf( pcCU, uiAbsPartIdx, TEXT_CHROMA_U, uiTrDepth, uiDepth );
-      }
-      if( bFirstCbfOfCU || pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, uiTrDepth - 1 ) )
-      {
-        m_pcEntropyDecoderIf->parseQtCbf( pcCU, uiAbsPartIdx, TEXT_CHROMA_V, uiTrDepth, uiDepth );
-      }
-    }
-    else
-    {
+        if( bFirstCbfOfCU || pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, uiTrDepth - 1 ) )
+        {
+          m_pcEntropyDecoderIf->parseQtCbf( pcCU, uiAbsPartIdx, TEXT_CHROMA_U, uiTrDepth, uiDepth );
+        }
+        if( bFirstCbfOfCU || pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, uiTrDepth - 1 ) )
+        {
+          m_pcEntropyDecoderIf->parseQtCbf( pcCU, uiAbsPartIdx, TEXT_CHROMA_V, uiTrDepth, uiDepth );
+        }
+      }
+      else
+      {
         if( bFirstCbfOfCU || pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, uiTrDepth - 1 ) )
         {
Index: branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1187)
@@ -290,6 +290,4 @@
     }
   }  
-
-
 }
 
@@ -349,4 +347,5 @@
 }
 #endif
+
 TDecTop::TDecTop()
 {
@@ -1197,5 +1196,7 @@
 #if  H_3D_TMVP
     if(pcSlice->getLayerId())
+    {
       pcSlice->generateAlterRefforTMVP();
+    }
 #endif
   }
@@ -1650,5 +1651,4 @@
 }
 
-#if H_MV
 Void TDecTop::xCeckNoClrasOutput()
 {
@@ -1684,4 +1684,28 @@
   return allRefLayersInitilizedFlag;
 }
+
+#if H_3D
+Void TDecTop::setProfileIdc()
+{
+  if (m_targetOptLayerSetIdx != -1 )
+  {    
+    TComVPS* vps = getPrefetchedVPS(); 
+    Int lsIdx = vps->olsIdxToLsIdx( m_targetOptLayerSetIdx );
+    Int lIdx = -1; 
+    for (Int j = 0; j < vps->getNumLayersInIdList( lsIdx ); j++ )
+    {
+      if ( vps->getLayerSetLayerIdList( lsIdx, j ) == getLayerId() )
+      {
+        lIdx = j; 
+        break; 
+      }        
+    }
+    assert( lIdx != -1 ); 
+
+    Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOptLayerSetIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
+    assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 ); 
+    m_profileIdc = profileIdc;   
+  };
+}
 #endif
 #endif
Index: branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecTop.h	(revision 1186)
+++ branches/HTM-14.0-dev0/source/Lib/TLibDecoder/TDecTop.h	(revision 1187)
@@ -301,26 +301,5 @@
   Void                    setCamParsCollector( CamParsCollector* pcCamParsCollector ) { m_pcCamParsCollector = pcCamParsCollector; }
 
-  Void                    setProfileIdc()
-  {        
-    if (m_targetOptLayerSetIdx != -1 )
-    {    
-      TComVPS* vps = getPrefetchedVPS(); 
-      Int lsIdx = vps->olsIdxToLsIdx( m_targetOptLayerSetIdx );
-      Int lIdx = -1; 
-      for (Int j = 0; j < vps->getNumLayersInIdList( lsIdx ); j++ )
-      {
-        if ( vps->getLayerSetLayerIdList( lsIdx, j ) == getLayerId() )
-        {
-          lIdx = j; 
-          break; 
-        }        
-      }
-      assert( lIdx != -1 ); 
-
-      Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOptLayerSetIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
-      assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 ); 
-      m_profileIdc = profileIdc;   
-    };
-  }
+  Void                    setProfileIdc();
   Bool                    decProcAnnexI()           { assert( m_profileIdc != -1 ); return ( m_profileIdc == 8); }    
 #endif
